SystemOrganization addCategory: #FuelPackageLoader!
SystemOrganization addCategory: #'FuelPackageLoader-Mappers'!
SystemOrganization addCategory: #'FuelPackageLoader-Metacello'!

FLFullGeneralMapper subclass: #FLPackageLoaderGeneralMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader-Mappers'!

!FLPackageLoaderGeneralMapper commentStamp: 'MartinDias 8/24/2011 00:08' prior: 0!
I am like the default mapper but with a special behavior with classes. I store a copy each class with just the local protocol.!

!FLPackageLoaderGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 15:29'!
visitClass: aClass  

	(Smalltalk globals includes: aClass)
		ifTrue: [ self visitSubstitution: aClass by: aClass copyWithLocalProtocol ]
		ifFalse: [ super visitClass: aClass ]! !

!FLPackageLoaderGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 4/19/2012 14:49'!
visitMetaclass: aMetaclass

	"We should find a better way of doing this"
	self flag: #fixIt.
	(Smalltalk globals includes: aMetaclass theNonMetaClass)
		ifTrue: [ self visitSubstitution: aMetaclass by: ((self clusterKeyedByClusterName: FLClassCluster) objects detect: [:each | each name =  aMetaclass theNonMetaClass name]) class ]
		ifFalse: [ super visitMetaclass: aMetaclass ]! !

!ClassOrganizer methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 01:32'!
removeCategorySilently: cat 

	super removeCategory: cat! !

!Association methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/24/2011 11:26'!
rebindOn: aCompiledMethod at: index
	"If the CompiledMethod was saved with a reference to a class that does exist, then its calculated binding will be nil. In that case we prefer to keep the original association."
	(aCompiledMethod methodClass bindingOf: key)
		ifNotNil: [:aBinding |
			aCompiledMethod literalAt: index put: aBinding]! !

!Behavior methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/22/2011 15:35'!
rebindMethodDictionary

	self methodDict valuesDo: [ :aCompiledMethod | 
		aCompiledMethod 
			methodClass: self;
			rebindLiterals. ]! !

!TClassAndTraitDescription methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 00:27'!
removeCategorySilently: aCategory

	SystemChangeNotifier uniqueInstance doSilently: [ self removeCategory: aCategory ]! !

FLAnalyzer subclass: #FLPackageAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!FLPackageAnalyzer methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 12/14/2011 20:44'!
generalMapper

	^FLPackageLoaderGeneralMapper new! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 21:16'!
cleanUpClassVariables

	self classPool keys do: [ :key | classPool at: key put: nil ]! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 21:41'!
cleanUpInstanceVariables

	Class instSize + 1 to: self class instSize do:
		[:offset | self instVarAt: offset put: nil].
! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MarianoMartinezPeck 4/21/2012 00:19'!
copyWithLocalProtocol

	| copy |
	copy := self copy.
	copy organization: organization deepCopy.
	copy environment: environment.
	copy basicCategory: category.	
	copy traitComposition: self traitComposition.
	copy classSide traitComposition: self classSide traitComposition.
	copy removeForeignProtocol.
	copy classSide removeForeignProtocol.
	copy cleanUpClassVariables.
	copy cleanUpInstanceVariables.
	^copy! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/29/2011 01:30'!
initializeOnLoad

	(self class includesSelector: #initialize)
		ifTrue: [self initialize]! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/29/2011 01:29'!
rebindOnLoad

	self rebindMethodDictionary.
	self class rebindMethodDictionary! !

!Class methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/29/2011 01:29'!
registerOnLoad

	superclass addSubclass: self. "Note that aClass could already be between its superclass subclasses, #addSubclass: is prepared for that case."
	Smalltalk globals at: self name put: self.
	Smalltalk globals organization classify: self name under: self basicCategory.! !

!Categorizer methodsFor: '*FuelPackageLoader' stamp: 'MarianoMartinezPeck 4/21/2012 18:28'!
classifySilently: element under: heading suppressIfDefault: aBoolean

	SystemChangeNotifier uniqueInstance doSilently: [
		self classify: element under: heading suppressIfDefault: aBoolean
	].
! !

!CompiledMethod methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/22/2011 02:10'!
rebindLiteralAt: index

	(self literalAt: index) rebindOn: self at: index! !

!CompiledMethod methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/22/2011 02:07'!
rebindLiterals 

	1 to: self numLiterals-2
		do: [ :index | self rebindLiteralAt: index ]! !

!Trait methodsFor: '*FuelPackageLoader' stamp: 'PavelKrivanek 4/11/2012 17:21'!
rebindMethodDictionary

	self methodDict valuesDo: [ :aCompiledMethod | 
		aCompiledMethod 
			methodClass: self;
			rebindLiterals. ]! !

!Trait methodsFor: '*FuelPackageLoader' stamp: 'MarianoMartinezPeck 4/16/2012 20:27'!
rebindOnLoad

	self rebindMethodDictionary.
	self class rebindMethodDictionary
	! !

!Trait methodsFor: '*FuelPackageLoader' stamp: 'PavelKrivanek 4/11/2012 17:19'!
registerOnLoad

	Smalltalk globals at: self name put: self.
	Smalltalk globals organization classify: self name under: self basicCategory.! !

Object subclass: #FLMetacelloStore
	instanceVariableNames: 'prefix capturing capturedPackageNames allPackagesTogetherStream'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'FuelPackageLoader-Metacello'!

!FLMetacelloStore commentStamp: 'MartinDias 9/29/2011 04:16' prior: 0!
I capture and export in Fuel files a Metacello load.

Example: loading Seaside 3

1) Install Fuel in a CLEAN Pharo 1.3 image:
Gofer it squeaksource: 'Fuel'; 
	package: 'Fuel';
	package: 'FuelPackageLoader';
	load.

2) Load the configuration you want to capture in this way:
FLMetacelloStore default 
	capturePackagesDuring: [
		Gofer new squeaksource: 'MetacelloRepository'; package: 'ConfigurationOfSeaside30'; load.
		(Smalltalk at: #ConfigurationOfSeaside30) project latestVersion load: #(Core)] 
	prefixed: 'seaside'.

= Load =

1) Install Fuel:
Gofer it squeaksource: 'Fuel'; 
	package: 'Fuel';
	package: 'FuelPackageLoader';
	load.

2) Now run the loading script generated: fileIn './FuelMetacello/seaside-load-.st'."

3) "Start the server"
WAComancheAdaptor startOn: 8088.!

!FLMetacelloStore classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 4/21/2012 17:24'!
default

	^Default ifNil: [Default := self new]! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:45'!
allPackagesTogetherFileName

	^prefix, '-all-packages-together.fuel'! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:54'!
capturePackages: packageNames

	packageNames
		do: [:packageName |
			capturedPackageNames add: packageName.
			FLPackageStore new storeOn: allPackagesTogetherStream packageNamed: packageName ]
		displayingProgress: [:packageName | 'Capturing ', packageName ]
	! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:41'!
capturePackagesDuring: aBlock prefixed: aPrefix

	capturedPackageNames := OrderedCollection new.
	prefix := aPrefix.

	self outputFileNamed:  self allPackagesTogetherFileName do: [:aStream |
		capturing := true.
		allPackagesTogetherStream := aStream binary.
		aBlock value.
		capturing := false ].

	self writeLoadingScript.
! !

!FLMetacelloStore methodsFor: 'initialize-release' stamp: 'MartinDias 9/29/2011 02:26'!
initialize 

	super initialize.
	capturing := false.! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:42'!
loadingScriptFileName
	
	^prefix, '-load.st'! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:41'!
loadingScriptString

	^ '
	| packageFileNames |
	packageFileNames := ', capturedPackageNames asArray printString, '.
	
	(FileDirectory default directoryNamed: ''FuelMetacello'') 
			oldFileNamed: ', self allPackagesTogetherFileName printString, ' 
			do: [ :aStream | 
				aStream binary.
				packageFileNames 
					do: [ :packageFileName | FLPackageLoader new loadFrom: aStream ]
					displayingProgress: [ :packageFileName | ''Fuel importing '', packageFileName ]]'! !

!FLMetacelloStore methodsFor: 'streaming' stamp: 'MartinDias 9/29/2011 02:26'!
outputDirectory

	^(FileDirectory default directoryNamed: 'FuelMetacello') 
		assureExistence;
		yourself
! !

!FLMetacelloStore methodsFor: 'streaming' stamp: 'MartinDias 9/29/2011 02:26'!
outputFileNamed: aFileName do: aBlock

	^self outputDirectory forceNewFileNamed: aFileName do: aBlock! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:26'!
packageFileNameFor: packageName
 
	^prefix, '-', packageName, '.fuel'! !

!FLMetacelloStore methodsFor: 'listening' stamp: 'MartinDias 9/29/2011 02:26'!
packagesHasBeenLoaded: packageNames

	capturing ifTrue: [ self capturePackages: packageNames]! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:43'!
writeLoadingScript

	self 
		outputFileNamed: self loadingScriptFileName 
		do: [ :scriptStream | scriptStream nextPutAll: self loadingScriptString ].! !

Object subclass: #FLMethodExtension
	instanceVariableNames: 'method category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!FLMethodExtension classSide methodsFor: 'instance creation' stamp: 'MartinDias 9/29/2011 01:53'!
with: aCompiledMethod

	^ self basicNew
		initializeWith: aCompiledMethod;
		yourself ! !

!FLMethodExtension methodsFor: 'accessing' stamp: 'MartinDias 3/26/2011 04:40'!
category
	^ category! !

!FLMethodExtension methodsFor: 'initialize-release' stamp: 'MartinDias 9/29/2011 01:52'!
initializeWith: aCompiledMethod

	self initialize.
	method := aCompiledMethod.
	category := aCompiledMethod category.! !

!FLMethodExtension methodsFor: 'loading' stamp: 'asdas 4/18/2012 19:10'!
load
	method rebindLiterals.
	method methodClass addSelectorSilently: method selector withMethod: method.
	method methodClass organization classifySilently: method selector under: category suppressIfDefault: true.

! !

!FLMethodExtension methodsFor: 'accessing' stamp: 'MartinDias 3/26/2011 04:40'!
method
	^ method! !

Object subclass: #FLPackage
	instanceVariableNames: 'extensionMethods behaviors'
	classVariableNames: 'InitializersEnabled'
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!FLPackage classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/16/2012 20:19'!
behaviorsLocalTo: packageInfo
	"Unfortuntly, the message #classes is a bad name because it answers both, classes and traits"
	^ packageInfo classes! !

!FLPackage classSide methodsFor: 'private' stamp: 'MartinDias 8/21/2011 19:21'!
extensionMethodsTo: packageInfo
	^ packageInfo extensionMethods 
		collect: [ :reference | FLMethodExtension with: reference compiledMethod ]! !

!FLPackage classSide methodsFor: 'initializers' stamp: 'MarianoMartinezPeck 4/21/2012 17:24'!
initializersEnabled

	^ InitializersEnabled ifNil: [ InitializersEnabled := true ].! !

!FLPackage classSide methodsFor: 'initializers' stamp: 'MarianoMartinezPeck 4/21/2012 17:25'!
initializersEnabled: aBoolean

	InitializersEnabled := aBoolean! !

!FLPackage classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 4/16/2012 20:21'!
named: packageName

	| packageInfo |
	packageInfo := PackageInfo named: packageName.
	^ self basicNew
		initializeWithBehaviors: (self behaviorsLocalTo: packageInfo) 
		extensionMethods: (self extensionMethodsTo: packageInfo);
		yourself! !

!FLPackage classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 4/16/2012 20:21'!
withPackages: packageNames

	| behaviors methods packageInfo |
	behaviors := OrderedCollection new.
	methods := OrderedCollection new.
	packageNames do: [:packageName |
		packageInfo := PackageInfo named: packageName.
		behaviors addAll: (self behaviorsLocalTo: packageInfo).
		methods addAll: (self extensionMethodsTo: packageInfo)].
	
	^ self basicNew
		initializeWithBehaviors: behaviors
		extensionMethods: methods;
		yourself! !

!FLPackage methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/16/2012 20:17'!
behaviors
	^ behaviors! !

!FLPackage methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/17/2012 17:38'!
classes
	^ behaviors select: [:each | each isBehavior]! !

!FLPackage methodsFor: 'accessing' stamp: 'MartinDias 3/26/2011 03:35'!
extensionMethods
	^ extensionMethods! !

!FLPackage methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/16/2012 20:21'!
initializeWithBehaviors: someBehaviors extensionMethods: someExtensionMethods

	self initialize.
	behaviors := someBehaviors.
	extensionMethods := someExtensionMethods.! !

!FLPackage methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/17/2012 17:43'!
load
	self behaviors do: [:aBehavior | aBehavior registerOnLoad].
	Smalltalk globals flushClassNameCache.
	self behaviors do: [:aBehavior | aBehavior rebindOnLoad].
	"We should not send #initialize to traits"
	(self classes sort: [:a :b | a allSuperclasses size < b allSuperclasses size ])
	 	do: [:aClass | 
			self class initializersEnabled
				ifTrue: [aClass initializeOnLoad]].
	self behaviors do: [:aBehavior | self notifyBehaviorAddition: aBehavior].
	self loadExtensionMethods.
	Behavior flushObsoleteSubclasses! !

!FLPackage methodsFor: 'loading' stamp: 'MartinDias 3/26/2011 04:44'!
loadExtensionMethods
	
	extensionMethods do: [ :extensionMethod | extensionMethod load ]! !

!FLPackage methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/19/2012 23:06'!
notifyBehaviorAddition: aBehavior

	 | category |

	category := aBehavior category ifNil: ['UNKNOWN'].
	"It looks like Traits use the same even than classes"
	SystemChangeNotifier uniqueInstance classAdded: aBehavior inCategory: category asSymbol.

! !

Object subclass: #FLPackageLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!FLPackageLoader methodsFor: 'loading' stamp: 'MartinDias 9/13/2011 22:01'!
loadFrom: aStream 

	| package |
	package := (FLMaterializer newDefault materializeFrom: aStream) root.
	package load.
	^ package.! !

Object subclass: #FLPackageStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!FLPackageStore methodsFor: 'storing' stamp: 'MarianoMartinezPeck 4/16/2012 20:23'!
storeOn: aStream packageNamed: name 

	| package |
	package := FLPackage named: name.
	(FLSerializer newDefault)
		analyzer: (FLPackageAnalyzer newDefault 
			considerInternalAll: package behaviors;
			yourself);
		serialize: package on: aStream.! !

!FLPackageStore methodsFor: 'storing' stamp: 'MarianoMartinezPeck 4/16/2012 20:23'!
storeOn: aStream packages: nameNames

	| package |
	package := FLPackage withPackages: nameNames.
	(FLSerializer newDefault)
		analyzer: (FLPackageAnalyzer newDefault 
			considerInternalAll: package behaviors; 
			yourself);
		serialize: package on: aStream.! !

Object subclass: #ManifestFuelPackageLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackageLoader'!

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 00:13'!
rejectClasses
^ #()! !

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 00:13'!
rejectRules
^ #()! !

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:25'!
ruleClassNotReferencedRuleV1FalsePositive
^ #(#('(RGClassDefinition named: #FLMetacelloStore)' #'2012-04-21T17:25:46.02+02:00') )! !

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:26'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLPackageLoaderGeneralMapper'' selector: #visitMetaclass: isMetaSide: false)' #'2012-04-21T17:26:41.256000001+02:00') )! !

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:36'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLMetacelloStore'' selector: #loadingScriptString isMetaSide: false)' #'2012-04-21T17:36:41.183000001+02:00') #('(RGMethodDefinition className: ''FLPackageLoaderGeneralMapper'' selector: #visitMetaclass: isMetaSide: false)' #'2012-04-21T17:36:41.547000001+02:00') )! !

!ManifestFuelPackageLoader classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 18:13'!
ruleOnlyReadOrWrittenTemporaryRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''ClassOrganizer'' selector: #classifySilently:under:suppressIfDefault: isMetaSide: false)' #'2012-04-21T18:13:46.796000001+02:00') )! !

!Object methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 9/22/2011 02:12'!
rebindOn: aCompiledMethod at: index
	"Nothing to do."! !

!ClassDescription methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 02:42'!
foreignCategories
	
	^self organization categories select: [ :aCategory | aCategory beginsWith: '*' ]! !

!ClassDescription methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 01:50'!
removeCategorySilently: aCategory

	(organization listAtCategoryNamed: aCategory) do: [ :aSelector | self removeSelectorSilently: aSelector ].
	organization removeCategorySilently: aCategory.
! !

!ClassDescription methodsFor: '*FuelPackageLoader' stamp: 'MartinDias 8/22/2011 03:05'!
removeForeignProtocol

	self foreignCategories do: [ :aCategory |
		self removeCategorySilently: aCategory ]! !
